#!/usr/bin/perl
use CGI;

my $q=new CGI;
#number of entries in the highscore
my $size=100;
#filename of the highscore list
my $highfile="highscore.txt";
#filename of the logfile
my $logfile="highscore.log";
#filename of the navigation html code
my $navstart="../../../navstart.txt";
#filename of the closing html code
my $navend="../../../navend.txt";

#get parameters
my $code=$q->param("code");
my $docbase=$q->param("docbase");
my $name=$q->param("name");
my $plain=decode($code,"98857bfef3d980e6");
my $score1=hex(substr($plain,8,4));
my $score2=hex(substr($plain,12,4));
my $score=($score1==$score2)?$score1:0;
if(!defined($docbase)) {
	$docbase="http://www.gamemakers.de/BoulderGame/";
}
if($name) {
	#add item to highscore list and return to game
	if(checkname($name)&&($score>0)) {
		addScore($name,$score,$code);
	}
	$q->print($q->redirect($docbase));
} else {
	open (FILE,"$highfile");
	my @lines=<FILE>;
	my $pos=getPosition($score,$code,@lines)/3+1;
	close (FILE);
	$q->print($q->header(-type=>"text/html",-expires=>"now"));
	#print navigation start
	open (FILE,"$navstart");
	q->print(<FILE>);
	close (FILE);
	#print content
	$q->print("<CENTER>");
	$q->print($q->h1("Your Score is $score"));
	if(($score>0)&&($lines[$size*2-1]<=$score)) {
		$q->print("<HR>");
		queryName($score,$code,$docbase,$pos);
	} else {
		$q->print("<A HREF=\"$docbase\">Try again?</A>");
	}
	$q->print("<HR>");
	showScore(@lines);
	$q->print("</CENTER>");
	#print navigation end
	open (FILE,"$navend");
	q->print(<FILE>);
	close (FILE);
}

sub queryName {
	my ($score,$code,$docbase,$pos)=@_;
	my $url=$q->url();
	$q->print($q->h2("Congratulations!"));
	$q->print($q->h2("you have made it into the highscore at position $pos!"));
	$q->print("<FORM ACTION=\"$url\">");
	$q->print("<INPUT TYPE=HIDDEN NAME=\"code\" VALUE=\"$code\">");
	$q->print("<INPUT TYPE=HIDDEN NAME=\"docbase\" VALUE=\"$docbase\">");
	$q->print("<INPUT TYPE=TEXT NAME=\"name\" VALUE=\"nobody\" MAXLENGTH=20>");
	$q->print("<INPUT TYPE=SUBMIT VALUE=\"submit\">");
	$q->print("</FORM>");
}

#display the score as a table
sub showScore {
	my @lines=@_;
	$q->print("<TABLE WIDTH=500>");
	for(my $i=0;$i<@lines;$i+=3) {
		$pos=$i/3+1;
		$q->print("<TR><TD ALIGN=LEFT>$pos");
		$q->print("<TD ALIGN=LEFT>$lines[$i]");
		$q->print("<TD ALIGN=RIGHT>$lines[$i+1]");
	}
	$q->print("</TABLE>");
}

#finds the correct position in the score
sub getPosition {
	my $score=shift();
	my $code=shift();
	my @lines=@_;
	#check for duplicates
	for(my $i=0;$i<scalar(@lines);$i+=3) {
		if($lines[$i+2] eq $code) {
			return undef;
		}
	}
	#find offset
	for(my $i=0;$i<scalar(@lines);$i+=3) {
		if($lines[$i+1]<=$score) {
			return $i;
		}
	}
	return scalar(@lines);
}

#add whatever is in $name/$score/$code into the score
sub addScore {
	my $name=shift();
	my $score=shift();
	my $code=shift();
	#cut name
	$name=substr($name,0,30);
	open (FILE,"$highfile");
	my @lines=<FILE>;
	my $msg="";
	my $log=localtime().",".$q->user_agent().",$docbase,";

	#remove cr
	chomp(@lines);
	
	#insert current score
	my $pos=getPosition($score,$code,@lines);
	if(defined($pos)) {
		splice(@lines,$pos,0,$name,$score,$code);
		$msg="Inserted at $pos";
	} else {
		$msg="Duplicate entry!";
	}

	#cut array if nessecary
	if(@lines>$size*3) {
		$#lines=$size*3;
	}

	#write new highscore
	open(OUT,">$highfile") || die("Error writing $highfile");
	for(my $i=0;$i<@lines;$i+=3) {
		print OUT "$lines[$i+0]\n";
		print OUT "$lines[$i+1]\n";
		print OUT "$lines[$i+2]\n";
	}
	close (OUT);
	close (FILE);
	
	#append log string to logfile
	$log.=$msg;
	open(LOG,">>$logfile") || die("Error writing $logfile");
	print LOG "$log\n";
	close(LOG);
}

sub decode {
	my $code=shift();
	my $codelen=length($code);
	if($codelen>=8) {
		my $score=hex(substr($code,$codelen-4,4))^0xDEF0;
		my $score2=hex(substr($code,$codelen-8,4))^0x9ABC;
		if($score!=$score2) {
			return 0;
		} else {
			return $score;
		}
	} else {
		return 0;
	}
}

sub checkname {
	$_=shift();
	if(/</i || />/i || /\./i || /@/i) {
	  	return 0;
	} else {
		return 1;
	}
}

sub decode {
	my ($code,$keyword)=@_;
	my $plain="";
	for(my $i=0;$i<length($code);$i+=8) {
		$plain.=sprintf("%08x",hex(substr($code,$i,8))^hex(substr($keyword,$i,8)));
	}
	return $plain;
}
